unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm2 = class(TForm)
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    FHLib:THandle;
    FChildID:integer;
    FChildHandle:THandle;
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

type
  TCreateCustomWindow=function(ParentHandle:integer;
    DataRect:TRect; var WinHandle:THandle):integer; stdcall;
  TDeleteCustomWindow=procedure(WinID:integer); stdcall;


procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TForm2.FormCreate(Sender: TObject);
var
  CreateW:TCreateCustomWindow;
begin
  FHLib:=LoadLibrary('ChildDLL.dll');
  if FHLib<>0 then begin
    CreateW:=GetProcAddress(FHLib,'CreateCustomWindow');
    if Assigned(CreateW) then 
     FChildID:=CreateW(Handle,ClientRect,FChildHandle);
  end;
end;

procedure TForm2.FormDestroy(Sender: TObject);
var
  DeleteW:TDeleteCustomWindow;
begin
  if (FChildID>0) and (FHLib<>0) then begin
    DeleteW:=GetProcAddress(FHLib,'DeleteCustomWindow');
    if Assigned(DeleteW) then DeleteW(FChildID);
  end;
  if FHLib<>0 then FreeLibrary(FHLib);
end;

end.
